int debug = 0;
int verbose  = 0;

/*
 LOUD_LISTENER       ENVISAGED DESIGNED AND ORIGINALLY CODED 
                                    BY LOUD-FAT-BLOKE
                            Recoded by -------
 ****************************************************************************
 *  For our lawful Intercept requirement I needed a light-weight high 
 *   speed voice packet recorder.
 * 
 *   Could not find one that could be armed to record
 *   one particular phone call - they seemed to record 
 *   all voice passing the Interface
 *   which really could not be used "lawfully" as I work for the 
 *   largest EUROPEAN voip carrier
 *
 *   Speed is also an issue - this code will work at 10 or 40Gbs
 *   on an optimised platform (providing your target isn't generating 
 *   more traffix than a PCI-X bus can handle)
 *
 *   Lastly I keep hearing that sniffing voice is "really easy" - I            
 *   wrote this code to be pushed to an FPGA so it has to be simple yet
 *   now I am even more convinced that to tap a particular call in a 
 *   large exchange is not simple
 *
 *   The program does the following 
 *           1 - search all packets on 5060 on the assumption that 
 *                        it is a SIP packet
 *           2 - If it is a SIP packet check to see if it includes SDP
 *           3 - Check to see if it is an INVITE packets
 *           4 - If it does check if it contains our string ideally a
 *                        telephone number or a sip url
 *           5 - if so extract RTP port and RTP ip address
 *           6 - Generate RTCP port 
 *           7 - Log all packets with the RTP port or RTCP port
 *                       that comes from/to the RTP addrees
 *           8 - Bail if the ssrc changes or time-out or sip bye 
 *                  or cancel
 *
 *  Future development
 *                  1 - we have a SIP field dissector that we wrote for
 *                    the CDR generater, we should use this to make the
 *                       search more selective
 *                  2 - Take parms from file and use get arg
 *                  3 - Do a gethostbyname for the rtp address
 *                  4 - do a getprotobyname
 *                  5 - add our MPLS stack that we wrote for snort and
 *                        the Interoute Internet Barometer 
 *                          http://barometer.interoute.com                                                           
 ****************************************************************************
* BETA TEST VERSION 
*                - RUN OUTSIDE A SECURITY HARD ENIRONMENT AT YOUR RISK
*                - DO NOT SPEND HOURS FUZZING PARAMETERS IN AN EFFORT 
*                     TO PUBLISH CHEAP  0-DAY VULNERABILITES
*  The program will be ported to an fpga soon soon so 
*                 
 ****************************************************************************

 */


/* ***********************************************************
Copyright (c) 2009, MARK OSBORNE [LOUD-FAT-BLOKE.CO.UK] &
                    INTEROUTE COMMUNICATIONS LTD            
                    ALL RIGHTS RESERVED.

THIS SOFTWARE IS FOR PRIVATE, NON-COMMERCIAL USE ONLY. 
USE WITHIN ANY ORGANIZATION OR FOR COMMERCIAL PURPOSES IS STRICTLY PROHIBITED.
THE FULL LICENSE AGREEMENT IS PROVIDED IN THE FILE NAMED  "LICENSE"
PROVIDED WITH THIS DISTRIBUTION.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, 
OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.


*******************************************************************************                  */

int fd;
#include <fcntl.h>

#include <pcap.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <errno.h>
#include <sys/types.h>

#include <sys/syslog.h>


#include <stdio.h>
#include <string.h>
//* #define __USE_BSD
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#define __FAVOR_BSD
#include <netinet/udp.h>
#include <unistd.h>
#include <arpa/inet.h>


#include <signal.h>
#include <time.h>
#define _GNU_SOURCE
#include <string.h>
#define         ALARM_DUR             30

/* default snap length (maximum bytes per packet to capture) */
#define SNAP_LEN 1518

/* ethernet headers are always exactly 14 bytes [1] */
#define SIZE_ETHERNET 14

/* Ethernet addresses are 6 bytes */
#define ETHER_ADDR_LEN	6

/* Ethernet header */
struct sniff_ethernet
{
  u_char ether_dhost[ETHER_ADDR_LEN];	/* destination host address */
  u_char ether_shost[ETHER_ADDR_LEN];	/* source host address */
  u_short ether_type;		/* IP? ARP? RARP? etc */
};

/* IP header */
struct ip *iph;			/*pointer to the IP structure (which contains the ip headers). */

#define IP_HL(ip)               (((ip)->ip_vhl) & 0x0f)

#define IP_V(ip)                (((ip)->ip_vhl) >> 4)
#define DEBUGIT(xxxx)           if ( debug == 1 ) printf(xxxx);

/* TCP header */
typedef u_int tcp_seq;

/* RTP header */

struct rtphdr
{
  unsigned int cc:4;
  unsigned int ext:1;
  unsigned int pad:1;
  unsigned int ver:2;
  unsigned int pt:7;
  unsigned int mark:1;
  u_int16_t seq;
  u_int32_t timestamp;
  u_int32_t ssrc;
  u_int32_t csrc;
};


int snap_len;

#include <sys/ioctl.h>
#include <net/if.h>
#include <netinet/in.h>
#include <netinet/in.h>
#include <arpa/inet.h>
static void timeout ();


// standard routine to get the MTU size of an interface
int
getmtu (char *itf)
{
  int if_fd;

  struct ifreq ifreq;

  if_fd = socket (AF_INET, SOCK_DGRAM, IPPROTO_IP);

  strcpy (ifreq.ifr_name, itf);


  /* get mtu off interface  */
  if ((ioctl (if_fd, SIOCGIFMTU, &ifreq)) != 0)
    {
      perror (" error getting MTU ");
      close (if_fd);
      return (SNAP_LEN);

    }
  else
    {
      close (if_fd);
      DEBUGIT (" getting MTU - ok ");
      return (ifreq.ifr_mtu);
    }
}



 /* print help text
  */
void
print_app_usage (void)
{
 fprintf(stderr,"Usage: loud_listener [-v -D -h ]  -i pnic-interface -s sip_identying_string \n \n \n \n");
 fprintf (stderr, "-%s \n", "h is for help    ");
 fprintf (stderr, "-%s \n", "v is for verbose ");
 fprintf (stderr, "-%s \n", "D is for debug   ");
 fprintf (stderr, "-%s \n", "i is for Pnic Interface");
 fprintf (stderr, "-%s \n", "s is for  sip_identying_string ");
 fprintf(stderr,"sip_identying_string  = any text in a sip invite either a sip url, telephone number or ip \n");

  return;
}

char *dev = NULL;		/* pcap name */
struct in_addr print_ip;	/*  address */
struct in_addr rtp_ip;		/*  address */
struct in_addr sip_dst_ip;	/*  address */
struct in_addr sip_src_ip;	/*  address */

char buffy[300];
char from_buffy[300];
char to_buffy[300];
char cmd_buffy[300], *END;
int buffy_end;

int xx = 0;
u_short rtp_port1;
short rtp_port2;
short rtcp_port1;
short rtcp_port2;
char from_add[19];
char *ch, *p;
char *sdp;
char *target;
char *target_callid;
static pcap_dumper_t *dumpd = NULL;
u_int32_t in_old_ssrc = 0;
u_int32_t out_old_ssrc = 0;
u_int32_t in_finished = 0;
u_int32_t out_finished = 0;
pcap_t *handle;			/* packet capture handle */
//
// reporting data
//
u_int32_t  sip_cnt =  0;
u_int32_t  rtp_in_cnt =  0;
u_int32_t rtp_out_cnt = 0;
u_int32_t rtcp_cnt = 0;
//     print out the summary  details  
print_sum()
  {
  printf ("Recorded session summary  \n");
  printf ("SIP records:                      %d  \n", sip_cnt );
  printf ("RTP records to target address     %d \n",  rtp_in_cnt);
  printf ("RTP records from  target address  %d \n",  rtp_out_cnt);
  printf ("RTCP records                      %d \n",  rtcp_cnt);
  printf ("   \n ");
  }
//   TODO:
//  This is the beta version in the production version 
//  we willi

// Get the sip call-id of the sip session
char *
get_callid (char *p)
{
  size_t n;
  char *ptr_start;
  char *ptr_end;
// 
  if ((ptr_start = strstr (p, "Call-ID:")) != NULL)
    {
      ptr_end = index (ptr_start, '\r');
      ptr_start = ptr_start + 9;
      n = ptr_end - ptr_start;
      return (strndup (ptr_start, n));
    }
  else
    {
      return (p);
    }
}



//     This opens the pcap save file
//* 
open_pcap_dump_file ()
{
//* TODO:
// we need a clever routine here to write to a file 
//    with name -
//          dump.log. [address rtp.out.d_ipi] .[address s_ip] . utc time 
//* 
  dumpd = pcap_dump_open (handle, "rtpout.pcap");
//  but this is simple  for the beta
}

// 
// Disect SDP       
// extract rtp port 
// 
void
get_sdp (char * payload)
{
  char  *p;

  if ((sdp = strstr (payload, "m=audio")) != NULL)
    {
      DEBUGIT ("found m=audio sdp  string in packet     \n");
      sdp = sdp + 8;
      rtp_port1 = (short) atoi (sdp);
      rtcp_port1 = rtp_port1 + 1;
      rtcp_port2 = rtp_port2 = 1;
    }
// Get one of three ip addresses in order of presidence side of rtp port 

  if ((sdp = strstr (payload, "o=")) != NULL)
    {
      DEBUGIT ("found o= - - IN IP4 string in packet     \n");
//  IN IP4 should be followed by an ip address
      if ((p = strstr (sdp, "IN IP4 ")) != NULL)
	{
	  p = p + 7;
	  strncpy (from_add, p, 13);
	  if (debug == 1)
	    fprintf (stderr, " SDP o= def contain address >>>%13s \n \n",
		     from_add);

	  xx = 1;
	}
    }
//
/// c= is for calls ip address             
  if ((sdp = strstr (payload, "c=IN IP4 ")) != NULL)
    {
//  IN IP4 should be followed by an ip address
      strncpy (from_add, sdp + 9, 15);
//  TODO:
//   on our exchange this is ALWAYS a dot decimal address 
//   but for the production model this should have a GETADDRBYNAME()
//   call to call the resolver
      if (debug == 1)
	fprintf (stderr, " SDP o= def contain address >>>%13s \n \n",
		 from_add);
    }
///
  rtcp_port2 = rtp_port2 = 1;
  print_ip.s_addr = inet_addr (from_add);	/* IP of destination host.  */
//*

}

/*
 * print  udp packet  
 */

void
print_udp (struct ip *iph, struct udphdr *udp)
{
  /* print source and destination IP addresses */
  printf ("From      : %s\n", inet_ntoa (iph->ip_src));
  printf ("To        : %s\n", inet_ntoa (iph->ip_dst));
  printf ("sport      : %d\n ", ntohs (udp->uh_sport));
  printf ("dpor       : %d \n ", ntohs (udp->uh_dport));

}
/*
 *   set up the fpga 
 */
void
set_fpga_filter()
{
// in this routine you call the P10 CUSTOM API
// to add a DYNAMIC rule to let the RTP trafic thru
//
// As this is PROPRIETARY between us and them details are withheld
//
// divert on all upd any any -> from_add any (msg:" ctime() getpid() "; ) 
// divert on all upd  from_add any -> from_add any (msg:" ctime() getpid() "; ) 
//
//  Won't effect most users as it is very expensive kit that you only need if 
//  you are a large user or multinational ISP
//
return;
}
/*
 *   unset  the fpga 
 */
void
unset_fpga_filter()
{
// in this routine you call the P10 CUSTOM API
// to remove  a DYNAMIC rule that you added abovec thru
//
// As this is PROPRIETARY between us and them details are withheld
//
return;
}
/*
 * dissect udp packet  
 */

void
proc_udp_packet (u_char * args, const struct pcap_pkthdr *header,
		 const u_char * packet)
{
  /* declare pointers to packet headers */
  const struct sniff_ethernet *ethernet;	/* The ethernet header [1] */
  struct ip *iph;		/*pointer to the IP structure (which contains the ip headers). */
  struct udphdr *udp;		/* The udp  header */

  char *payload;		/* Packet payload */
  int size_ip;
  int size_tcp;
  int size_payload;

  /* map    ethernet header */
  ethernet = (struct sniff_ethernet *) (packet);

  /* define/compute ip header offset */
  iph = (struct ip *) (packet + SIZE_ETHERNET);
  size_ip = iph->ip_hl * 4;
  if (size_ip < 20)
    {
      printf ("   * Invalid IP header length: %u bytes\n", size_ip);
      return;
    }

  /* determine protocol */
  switch (iph->ip_p)
    {
    case IPPROTO_TCP:
      return;
    case IPPROTO_UDP:
      break;

    default:
      perror ("   Protocol: unknown-skipping");
      return;
    }

  /*
   *  OK, this packet is UDP  
   */
  udp = (struct udphdr *) (packet + SIZE_ETHERNET + size_ip);

  if (debug == 1)
    {
      /* print source and destination IP addresses */
      printf ("       From: %s\n", inet_ntoa (iph->ip_src));
      printf ("         To: %s\n", inet_ntoa (iph->ip_dst));
      /* print source and destination ports
       * */
      printf ("sport dport %i %i ", ntohs (udp->uh_sport),
	      ntohs (udp->uh_dport));
    }

  /* define/compute udp payload (segment) offset */
  payload = (u_char *) (packet + SIZE_ETHERNET + size_ip + 8);


  /* compute udp  payload (segment) size */
  size_payload = ntohs (iph->ip_len) - (size_ip + 8);

  memset (from_add, ' ', 17);

//* Get Sip packet  
//      

  if (((ntohs (udp->uh_dport) == 5060) && xx == 0)
      || ((ntohs (udp->uh_sport) == 5060) && xx == 0))
    {
      DEBUGIT ("is a sip packet \n");
      strncpy (cmd_buffy, payload, 90);
      if ((strncmp (cmd_buffy, "INVITE ", 6) == 0)
	  && (strstr (payload, "application/sdp") != NULL))
	{
	  DEBUGIT ("found  an invite with a sdp extentension \n");
	  if ((strstr (payload, target)) == NULL)
	    return;
	  DEBUGIT ("found  target string in packet     \n");

// extract rtp port 

	  if ((strstr (payload, "m=audio")) != NULL)
	    {
	      DEBUGIT ("found m=audio sdp  string in packet     \n");
	      get_sdp (payload);
//*
//  if we are here we found an SIP INVITE containing out target sting 
//     print out the details  
          if ( verbose == 1 )
              {
	      printf ("SIP invite found  \n");
	      printf ("S-ip: %s  \n", inet_ntoa (iph->ip_src));
	      printf ("D-ip: %s  \n", inet_ntoa (iph->ip_dst));
	      printf ("Containing search string:  %s \n", target);
	      printf ("With RTP address %s \n", from_add);
	      printf ("rtp port 1 %i \n ", rtp_port1);
	      printf ("rtcp port 1 %i \n ", rtcp_port1);
	      printf ("   \n ");
              }
//   TODO:
//  This is the beta version in the production version 
//  we willi
//   1-fork here and let the child record the call
//            whilst the parent  continues to look for target calls
//   2-set the FPGA filter on the nic to pickup tarffic
//
              set_fpga_filter();
	      open_pcap_dump_file ();
	      pcap_dump ((u_char *) dumpd, header, packet);
              sip_cnt++   ;
//
	      target_callid = get_callid (payload);

	    }
	}
      return;
    }


  /*  xx== 1 means we are ARMED searching for rest of  stream 
   * */
  if (((ntohs (udp->uh_dport) == 5060) && xx == 1)
      || ((ntohs (udp->uh_sport) == 5060) && xx == 1))
    {
//          look for matching sip traffic 
      if ((strstr (payload, target_callid) != NULL))
	{
	  if ((strstr (payload, target)) == NULL)
	    return;
	  pcap_dump ((u_char *) dumpd, header, packet);
          sip_cnt++   ;
	  strncpy (cmd_buffy, payload, 10);
	  cmd_buffy[11] = '\0';
  if (debug == 1)
	  printf ("packet with calllid>> %s << %s<<<<<<%s<<<<<<<\n",
		  get_callid (payload), target_callid, cmd_buffy);
	  if ((strncmp (cmd_buffy, "BYE ", 4) == 0))
	    {
	      DEBUGIT ("xxxxxxx BYE found  xxxxx\n");
	      cleanup ();
	      exit(0);
	    }
	  if ((strncmp (cmd_buffy, "CANCEL ", 5) == 0))
	    {
	      DEBUGIT (" xxxxx CANCEL found  xxxxxxxxxxxxx\n");
	      cleanup ();
	      exit(0);
	    }
	}
    }


  /*  xx== 1 means we are ARMED searching for a particular RTP stream 
   * */

  if (xx == 1)
    {
// Process outbound rtp
      if ((ntohs (udp->uh_sport) == rtp_port1
	   && iph->ip_src.s_addr == print_ip.s_addr))
	{
          DEBUGIT ("rtp packet \n");
	  /* print source and destination IP addresses/ ports */
          if ( verbose == 1 )
	     print_udp (iph, udp);
	  do_rtp_out ((struct rtphdr *) payload);
	  /* 
	     DUMP it out 
	   */
          rtp_out_cnt++  ;
	  pcap_dump ((u_char *) dumpd, header, packet);

	}
    }

  /*  xx== 1 means we are ARMED searching for a particular RTP stream 
   * */

  if (xx == 1)
    {
// Process inbound rtp
      if ((ntohs (udp->uh_dport) == rtp_port1
	   && iph->ip_dst.s_addr == print_ip.s_addr))
	{
          DEBUGIT ("rtp packet \n");
	  /* print source and destination IP addresses/ ports */
          if ( verbose == 1 )
	      print_udp (iph, udp);
	  do_rtp_in ((struct rtphdr *) payload);
	  /* 
	     DUMP it out 
	   */
          rtp_in_cnt++  ;
	  pcap_dump ((u_char *) dumpd, header, packet);

	}
    }

  /*  xx== 1 means we are ARMED searching for a particular RTCP stream */


  if (xx == 1)
    {
// Process  rtcp
      if (((ntohs (udp->uh_dport) == (rtp_port1 + 1))
	   && iph->ip_dst.s_addr == print_ip.s_addr)
	  || ((ntohs (udp->uh_sport) == (rtp_port1 + 1))
	      && iph->ip_src.s_addr == print_ip.s_addr))
	{
          DEBUGIT (" rtcp packet\n");
	  /* print source and destination IP addresses */
          if ( verbose == 1 )
	      print_udp (iph, udp);
          rtcp_cnt++  ;
	  pcap_dump ((u_char *) dumpd, header, packet);
	  /* */
	}
    }
//
//
//   all done
//
  if (xx == 1)
    {
      if (in_finished == 1 && out_finished == 1)
	{
          DEBUGIT (" RTP  streams ended  \n");
	  cleanup ();
	  exit;
	}
    }
// end of proc_udp_packet
}

//* Setup BPF filters 

char errbuf[PCAP_ERRBUF_SIZE];	/* error buffer */
char filter_exp[120] =
  "\0                                                                      ";
//*                                                          "; /* filter expression - keep spaces */
struct bpf_program fp;		/* compiled filter program (expression) */
bpf_u_int32 mask;		/* subnet mask */
bpf_u_int32 net;		/* ip */


void
pcap_build_filter ()
{
/*
	 compile the filter expression */

  if (pcap_compile (handle, &fp, filter_exp, 0, net) == -1)
    {
      fprintf (stderr, "Couldn't parse filter %s: %s\n",
	       filter_exp, pcap_geterr (handle));
      exit (EXIT_FAILURE);
    }


  /* apply the compiled filter */


  if (pcap_setfilter (handle, &fp) == -1)
    {
      fprintf (stderr, "Couldn't install filter %s: %s\n",
	       filter_exp, pcap_geterr (handle));
      exit (EXIT_FAILURE);
    }
}

// print rtp packet

print_rtp (struct rtphdr *rtp)
{
  // print packet 
  printf ("Padding   : %d\n", rtp->pad);
  printf ("Extension : %d\n", rtp->ext);
  printf ("CSRC count: %d\n", rtp->cc);
  printf ("Mark      : %d\n", rtp->mark);
  printf ("Payload   : %d\n", rtp->pt);
  printf ("SeqNo     : %d\n", ntohs (rtp->seq));
  printf ("Timestamp : %d\n", rtp->timestamp);
  printf ("SSRC      : %i\n", ntohl (rtp->ssrc));
  printf ("CSRC      : %d\n", rtp->csrc);
  printf (" \n");
  printf (" \n");

}


// proc  rtp packet inwards


do_rtp_out (struct rtphdr *rtp)
{
  if (out_finished == 1)
    return;
// just print out a rtp  packet 
  if (verbose == 1)
     print_rtp (rtp);
  //  NOT SEEN A RTP packet before 
  if (out_old_ssrc == 0)
    out_old_ssrc = rtp->ssrc;
  if (out_old_ssrc != rtp->ssrc)
    {
          DEBUGIT("change rtp stream\n");
//         close files and exit

      out_finished = 1;
      return;
    }
  timeout ();
}



// proc  rtp packet outwards


do_rtp_in (struct rtphdr * rtp)
{
  if (in_finished == 1)
    return;
// just print out a rtp  packet 
  if (verbose == 1)
    print_rtp (rtp);
  //  NOT SEEN A RTP packet before 
  if (in_old_ssrc == 0)
    in_old_ssrc = rtp->ssrc;
  if (in_old_ssrc != rtp->ssrc)
    {
          DEBUGIT (" change rtp stream\n");
//         close files and exit

      in_finished = 1;
      return;
    }
  timeout ();
}


//         close files and exit

cleanup ()
{
  /* cleanup bpf filters */
  printf ("hit clean up \n");
  print_sum();
  fflush (stdout);
  pcap_freecode (&fp);
  /* close  input  */
  pcap_close (handle);
  /* close output file */
  pcap_dump_close (dumpd);
  /* cleanup fpga  filters */
  unset_fpga_filter();
  exit(0);
}

// catch alarm signal 

static void
timeDout ()
{
  fprintf (stderr, " Timed out  \n");
  fflush (stderr);
  cleanup ();
}

//  set up  alarm signal 


static void
timeout ()
{
  signal (SIGALRM, &timeDout);
  alarm (ALARM_DUR);
}

 /****************************************************************************  */
 /****************************************************************************  */
 /****************************************************************************  */


void
doargs (int argc, char **argv)
{
  char c;
  int p_cnt = 0;
// fprintf(stderr,"Usage: program [-v -D -h ]  -i pnic-interface -s sip_identying_string \n");
//* Usage: program [-v -D -h] -m [T|N]  -i pnic-interface [-f from-add ] -d  to-add -o to-interface
  while ((c = getopt (argc, argv, "vDi:s:")) != -1)
    {
      switch (c)
	{
	case 'h':
	  fprintf (stderr, "-%s \n", "h is for help    ");
          print_app_usage ();
          fflush (stderr);
          exit (1);
	case 'v':
	  fprintf (stderr, "-%s \n", "v is for verbose ");
	  verbose = 1;
	  break;
	case 'D':
	  fprintf (stderr, "-%s \n", "D is for debug   ");
	  debug = 1;
	  verbose = 1;
	  break;
	case 'i':
	  fprintf (stderr, "-%s \n", "i is for Pnic Interface");
	  fprintf (stderr, "%s \n", optarg);
	  dev  =        strdup (optarg);
	  p_cnt++;
	  break;
	case 's':
	  fprintf (stderr, "-%s \n",
		   "s is for filter on a specifc dest address");
	  fprintf (stderr, "%s \n", optarg);
	  target= strdup (optarg);	/* string              */
	  p_cnt++;
	  break;
	default:
	  fprintf (stderr, "invalid option: -%c, try -h for help\n", c);
	  break;

	}
    }

  if (p_cnt < 2)
    {
      fprintf (stderr, "error: Not enough parameters        \n");
      print_app_usage ();
      fflush (stderr);
      exit (1);
    }
  fflush (stderr);
}


 /****************************************************************************  */
 /****************************************************************************  */
 /****************************************************************************  */
//
// main
//
int
main (int argc, char **argv)
{

  int n = 0;			/* number  */

  sprintf (filter_exp, "udp  \n");
  if (debug == 1)
    fprintf (stderr, " Apply filter  :%s  \n", filter_exp);

  /* check for capture device name on command-line 
   */
  if (argc != 0)
    {
      doargs (argc, argv);
      printf ("search string:->  %s <------- \n", target);

    }

  else
    {
      fprintf (stderr, "error: unrecognized command-line options\n\n");
      print_app_usage ();
      exit (EXIT_FAILURE);
    }

  /* open capture device */
  /* 
     in future versions we may change it 
     to operate off a pcap file stored in stage 1 proccessing 
     so will need a command like this
     handle = pcap_open_offline(dev,  errbuf);
     handle = pcap_open_live(dev, SNAP_LEN, 1, 100, errbuf);

     handle = pcap_open_offline(dev,  errbuf);
     * */
  snap_len = getmtu (dev);
  handle = pcap_open_live (dev, snap_len, 1, 100, errbuf);
  if (handle == NULL)
    {
      fprintf (stderr, "Couldn't open file %s: %s\n", dev, errbuf);
      exit (EXIT_FAILURE);
    }

  signal (SIGALRM, &timeDout);
//* 
//*
  pcap_build_filter ();
  pcap_loop (handle, (int) 0000, proc_udp_packet, NULL);
//*   
//* Should never hit this
  printf ("about to main hit clean up \n");
  fflush (stdout);


}
